import * as __WEBPACK_EXTERNAL_MODULE_react__ from "react";
const FormItemParentNameContext = (0, __WEBPACK_EXTERNAL_MODULE_react__.createContext)({
    name: '',
    sort: ''
});
const FormItemParentNameProvider = (props)=>{
    const { name, sort, children } = props;
    const value = (0, __WEBPACK_EXTERNAL_MODULE_react__.useMemo)(()=>({
            name,
            sort
        }), [
        name,
        sort
    ]);
    return (0, __WEBPACK_EXTERNAL_MODULE_react__.createElement)(FormItemParentNameContext.Provider, {
        value,
        children
    });
};
const useFormItemParentName = (options)=>{
    const { isJoinParentField = true, sort, name } = options;
    const parentItem = (0, __WEBPACK_EXTERNAL_MODULE_react__.useContext)(FormItemParentNameContext);
    const parentName = parentItem.name;
    const parentSort = parentItem.sort;
    const newName = (0, __WEBPACK_EXTERNAL_MODULE_react__.useMemo)(()=>{
        if (parentName && isJoinParentField) {
            if (/^\./.test(`${name}`)) ;
            else if (name) return [
                parentName,
                '.',
                name
            ].filter(Boolean).join('');
            return [
                parentName,
                name
            ].filter(Boolean).join('');
        }
        return [
            name
        ].filter(Boolean).join('');
    }, [
        isJoinParentField,
        name,
        parentName
    ]);
    const newSort = (0, __WEBPACK_EXTERNAL_MODULE_react__.useMemo)(()=>[
            isJoinParentField ? parentSort : '',
            sort
        ].filter(Boolean).join('-'), [
        isJoinParentField,
        parentSort,
        sort
    ]);
    return {
        newName,
        newSort,
        parentItem,
        parentName: parentName
    };
};
export { FormItemParentNameContext, FormItemParentNameProvider, useFormItemParentName };
