import * as __WEBPACK_EXTERNAL_MODULE_react__ from "react";
import * as __WEBPACK_EXTERNAL_MODULE__useForm_js_e31b00cd__ from "./useForm.js";
import * as __WEBPACK_EXTERNAL_MODULE__useFormItem_js_ee04de55__ from "./useFormItem.js";
class WatchInstanceBase {
    name;
    form;
    oldValue;
    dispatch;
    callBack;
    updated = ()=>{
        const newValue = this.form.getFieldValue(this.name);
        if (this.oldValue === newValue) return;
        if (this.callBack) this.callBack(newValue, this.form);
        else this.dispatch(newValue);
    };
}
const useWatch = (name, form, callBack)=>{
    const formInstance = form || (0, __WEBPACK_EXTERNAL_MODULE__useForm_js_e31b00cd__.useFormInstance)();
    const [oldValue, setValue] = (0, __WEBPACK_EXTERNAL_MODULE_react__.useState)(formInstance.getFieldValue(name));
    const watch = (0, __WEBPACK_EXTERNAL_MODULE_react__.useRef)(new WatchInstanceBase()).current;
    watch.name = name;
    watch.oldValue = oldValue;
    watch.dispatch = setValue;
    watch.callBack = callBack;
    watch.form = formInstance;
    const formItemInstance = (0, __WEBPACK_EXTERNAL_MODULE__useFormItem_js_ee04de55__.useFormItem)();
    (0, __WEBPACK_EXTERNAL_MODULE_react__.useMemo)(()=>formItemInstance.ctor(name), []);
    formItemInstance.instance = formInstance;
    formItemInstance.isWatch = true;
    formItemInstance.updated = watch.updated;
    (0, __WEBPACK_EXTERNAL_MODULE_react__.useEffect)(()=>{
        const unMount = formInstance.registerFormItem(formItemInstance);
        return ()=>unMount();
    }, []);
    return [
        oldValue,
        formInstance,
        watch
    ];
};
export { WatchInstanceBase, useWatch };
